//Title:        Access Road
//Version:      0.7.0
//Copyright:    2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.AcsAddon.Accbee.MySQL.gBaseBeanInfo;

import ARoad0.gBaseBeanInfo.*;
import ARoad0.AcsAddon.Accbee.MySQL.gBaseInterface.*;

import java.beans.BeanDescriptor;
import java.beans.PropertyDescriptor;

/**
 * This class is responsible for describing the DirectoryMySQLImpl class.
 * It adds a property descriptor for the ResourceImpl property 'InheritedTargetAclEntries',
 * and uses the same event for the method getM_PrimaryTargetACLRights().
 * Add a panel group name to the property 'AclRights' to describe the MySQL ACLs.
 * Remove the Basic tab 'Alias' and the Resource 'M_ConstrainedChildACS' property.
 * Change the property descriptor of 'ParentNode' in '  ACL Inheritance  '.
 */
public class DirectoryMySQLImplBeanInfo extends DirectoryImplBeanInfo {

  public DirectoryMySQLImplBeanInfo() {}

  /**
   * Get the description of the bean.
   * Specific values are set in the descriptor. There is no method to change
   * the class of a BeanDescriptor, so, to reuse the BeanInfo of the mother class,
   * the values are copied in a new BeanDescriptor.
   * Copy all the changes done in ResourceMySQLImplBeanInfo,
   * since it is not its superclass.
   * @return the bean descriptor
   */
  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor result = new BeanDescriptor(DirectoryMySQL.class );
    result.setDisplayName("Directory");

    result = getCommonBeanDescriptor(result);

    return result;
  } // getBeanDescriptor()

  /**
   * Simply calls ResourceMySQLImplBeanInfo.getResourceMySQLPropertyDescriptors().
   * @return array of property descriptors
   */
  public PropertyDescriptor[] getPropertyDescriptors() {
      // starting from the parent class bean info
      return ResourceMySQLImplBeanInfo.getResourceMySQLPropertyDescriptors(
              super.getPropertyDescriptors() );

  } // getPropertyDescriptors()

} // DirectoryMySQLImplBeanInfo