//Title:        Access Road
//Version:      0.7.0
//Copyright:    2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.AcsAddon.Accbee.MySQL.gBaseInterface;

import ARoad0.gBaseInterface.*;

/**
 * This interface is responsible for modeling a MySQL GroupID to
 * manage the constraints on the account membership. <P>
 * A host in MySQL is simulated by an accounts group with a specific type. When
 * an user is connected from different hosts, the user may put the user account
 * in varied host groups. There is a constraint to enforce exactly one host to each account,
 * and the local host is the default one for a new user account. <P>
 * @version 0.7.0
 */
public interface GroupIDMySQL extends GroupID, ACSObjectAddon {
    
  /**
   * Returns true if the type is one of the 4 simple host types, and false
   * for a pattern-name_hosts group.
   * @return true if this GroupID is a MySQL simple host
   */
  public boolean isSimpleHost();

} // GroupIDMySQL
