//Title:        Access Road
//Version:      0.7.0
//Copyright:    2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.AcsAddon.Accbee.MySQL.gBaseInterface;

/**
 * This interface is responsible for modeling a MySQL proxy user having a proxied user
 * as hard alias reference. The proxied account is never a proxy account.
 * This interface gets most of the UserIDMySQL features,
 * but there are important differences: <P>
 * - a proxy user is never member of an account-for-hosts group. <P>
 * - for a new proxy user 'xxxx', there is no empty non-conditional ACL on 'MySQL Server'
 * for the accounts-for-hosts group 'xxxx§@%'. <P>
 * @version 0.7.0
 */
public interface ProxyMySQL extends UserIDMySQL {

  /**
   * Gets the proxied account under which this proxy account gets MySQL rights.
   * @return the proxied account. Never null.
   */
  public UserIDMySQL getProxiedAccount();

} // ProxyMySQL
