//Title:        Access Road
//Version:      0.7.0
//Copyright:    2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.AcsAddon.Accbee.MySQL.gBaseInterface;

import ARoad0.gBaseInterface.*;
import ARoad0.AcsAddon.Accbee.MySQL.gBase.GroupIDMySQLImpl;

/**
 * This interface is responsible for modeling a MySQL UserID to
 * manage the constraints on the account membership. <P>
 * A host in MySQL is simulated by an accounts GroupIDMySQL with a specific type.
 * It is always associated to an open ACS.
 * There is at least one host per MySQL user. <P>
 * @version 0.7.0
 */
public interface UserIDMySQL extends UserID, ACSObjectAddon {
    
  /**
   * @return the immutable first host of this MySQL user. May be null only if finalized.
   */
  public GroupIDMySQLImpl getEorFirstHost();

} // UserIDMySQL


