//Title:        Access Road
//Version:      0.7.0
//Copyright:    2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.AcsAddon.Accbee.Ubuntu.gBaseInterface;

import ARoad0.gBaseInterface.*;

/**
 * This interface is responsible for modeling a Linux Ubuntu directory.
 * It may change its group, and it has an umask and a sticky bit.
 * It is a javabean with the following bound properties:
 * 'StickyBit'.
 * @version 0.7.0
 */
public interface DirectoryUbuntu extends ResourceUbuntu, Directory {
    /**
     * @return boolean true if directory/file children
            are deleted only by the owner.
    */
    public boolean getStickyBit();

    /**
   * Noop if 'AGO right 3: at administration, only node owner has
   * the deleting and renaming rights, if activated' is not in the ACS rules.
   * No updating of the current children AGO rights.
   * @param _a true if directory/files
   *     are deleted or renaming only by their owner.
   */
   public void setStickyBit(boolean _a);

} // DirectoryUbuntu

