//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.ErrB;

import java.util.ArrayList;
import java.util.List;

/**
 * This class is responsible for collecting the errors
 * about the Access Road base.
 * Handle string format of the collected exceptions.
 * Sometimes, it collects the CreateErrors and UpDateErrors.
 */
public class BaseError extends Exception implements Cloneable { // is Serializable

    protected ArrayList l_Exception_;  // contains String and exceptions

    public BaseError() {
      l_Exception_ = new ArrayList(5);
    }

    /**
     * @param _st message to keep
     */
    public BaseError(String _st) {
      super(_st);
      
            //System.out.println("new BaseError :" + _st);

      l_Exception_ = new ArrayList(5);
      l_Exception_.add(_st);
    }

    /**
     * @param _e exception to keep
     */
    public void addException(Exception _e) {
      l_Exception_.add(_e);
      //System.out.println(toString());
    }

    /**
     * @param _st exception to keep
     */
    public void addException(String _st) {
      l_Exception_.add(_st);
      //System.out.println(toString());
    }

    /**
     * @return list of messages and exceptions
     */
    public List getL_Exception() {
      return (List) l_Exception_.clone();
    }

    /**
     * @return the last exception or message
     */
    public Object getLastException() {
      return (Object) l_Exception_.get(l_Exception_.size() - 1);
    }
    
    /**
     * @return a copy of this instance
     */
    public Object clone() {
      try {
        BaseError clon = (BaseError) super.clone();
        clon.l_Exception_ = (ArrayList) l_Exception_.clone();
        return clon;
      } catch (CloneNotSupportedException e) {
        throw new InternalError(e.toString());
      }//catch
    }

    /**
     * @param _obj to compare
     * @return true if equal
     */
    public synchronized boolean equals(Object _obj) {
      if (this == _obj)
          return true;
      if (_obj == null)
          return false;
      if (getClass() != _obj.getClass() )
          return false;

      BaseError obj = (BaseError) _obj;

      if (l_Exception_ == null | obj.getL_Exception() == null) {
        if (l_Exception_ != null | obj.getL_Exception() != null )
          return false;  // if
      } // if
      else {
        if (!l_Exception_.equals(obj.getL_Exception()) )
          return false;
      } //else

      return true;
    } // equals()

    //protected void finalize() {
      // todo: copy in a file
    //}

    /**
     * @return the message
     */
    public String toString() {
      return getMessage();
    }
} // BaseError