//Title:        Access Road
//Version:      0.6.0
//Copyright:    2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.ErrW;

import java.lang.Exception;
import java.util.Vector;
import java.util.List;

/**
 * This error class is responsible to point out the errors
 * in the Gui1/Gui2/gDMak/gWork process.
 * Sometimes, it collects the SmallErrors.
 * @version 0.5.0
 */
public class ProcessError extends Exception implements Cloneable { // is Serializable

    /**
     * Vector of all the exceptions or strings received by this class.
     */
    static protected Vector l_Exception__ = new Vector(1);;  // contains String or Exception

    public ProcessError() {
    }

    /**
	 * @param _st
	 */
	public ProcessError(String _st) {
      System.out.println("new ProcessError :" + _st);
      l_Exception__.add(_st);
    }

    /**
	 * @param _e
	 */
	public void addException(Exception _e) {
      l_Exception__.add(_e);
      return;
    }

    /**
	 * @param _st
	 */
	public void addException(String _st) {
      l_Exception__.add(_st);
      return;
    }

    /**
	 * @return list
	 */
	public List getL_Exception() {
        return (List) l_Exception__.clone();
    }

    /**
	 * @return object
	 */
	public Object clone() {
      try {
        ProcessError clon = (ProcessError) super.clone();
        clon.l_Exception__ = (Vector) l_Exception__.clone();
        return clon;
      } catch (CloneNotSupportedException e) {
        throw new InternalError(e.toString());
      }//catch
    }

    /**
	 * @param _obj
	 * @return true if equals
	 */
	public synchronized boolean equals(Object _obj) {
      if (this == _obj)
          return true;
      if (_obj == null)
          return false;
      if (getClass() != _obj.getClass() )
          return false;

      ProcessError obj = (ProcessError) _obj;

      if (l_Exception__ == null | obj.getL_Exception() == null) {
        if (l_Exception__ != null | obj.getL_Exception() != null )
          return false;  // if
      } // if
      else {
        if (!l_Exception__.equals(obj.getL_Exception()) )
          return false;
      } //else

      return true;
    } // equals()

    protected void finalize() {
      // copy in a file
      return;
    }

    /**
     * @return the string
     */
    public String toString() {
      StringBuilder sb = new StringBuilder();
      //sb.append("PROCESS_ERROR.TOSTRING() :");

      //sb.append("l_Exception__ = ");

      sb.append("Last error message: ");
      sb.append(l_Exception__.lastElement() );

      return sb.toString();
    }
} // ProcessError