//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui1;

import ARoad0.ErrW.ProcessError;
import ARoad0.gBaseInterface.BaseObject;

/**
 * This interface is responsible for signaling a class
 * which can handle the add/remove method for
 * the updating of a BaseObject.
 * The BaseObjectCreator caller
 * has to implement this interface (for instance, CollectionPropertyEditor)
 * if it manages a list of BaseObjects.
 */
public interface AddRemoveBaseObjectListener extends NewBaseObjectListener {

  /**
  * Called by BaseObjectCreator for actionPerformed(),
  * when the property is a BaseObject
  * which has to be created from scratch.
  * @param _l_obj is the BaseObjectCreator instance to add
  */
  public void addOneBaseObject(Object[] _l_obj) throws ProcessError;

  /**
  * Called by BaseObjectCreator for actionPerformed(),
  * when the property is a BaseObject
  * which has to be removed.
  * @param _l_obj is the BaseObjectCreator instance to remove
  */
  public void removeOneBaseObject(Object[] _l_obj) throws ProcessError;
  
  /**
   * Gets the value of the property source on which the base object
   * is added or removed.
   * @return the source of the property.
   */
  public BaseObject getSource();
}