//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui1;

import javax.swing.*;
import java.beans.*;
import ARoad0.Pattern.*;

/**
 * The change listener insists that there is always
 * at least one noniconified frame.
 * @version 0.4.0
 */
public class IconPolice implements Singleton, VetoableChangeListener {

    /* the only instance of the class, following singleton pattern */
    protected static IconPolice instance_ = new IconPolice();

    /**
 * with this private constructor, the compiler won't generate
 * a default public constructor.
 */
private IconPolice() {
  }
    /**
 * Only mean to get an instance.
 * @return IconPolice
 */
public static synchronized IconPolice getInstance(){
      return instance_;
}
        
 /**
 * This method controls the number of iconified frames to forbid iconfication
 * of all frames.
 * @param _ev PropertyChangeEvent
 * @exception PropertyVetoException
 */
public synchronized void vetoableChange(PropertyChangeEvent _ev)
    throws PropertyVetoException {

        String name = _ev.getPropertyName();
        if (name.equals(JInternalFrame.IS_ICON_PROPERTY)
        && (_ev.getNewValue() == Boolean.TRUE)) {
          JInternalFrame[] frames = Desktop.getCurrentFrames();
          int count = frames.length;
          int nonicons = 0;
          //how many frames are not icons?
          for (int i=0; i<count; i++) {
            if (frames[i].isIcon() == false) {
              nonicons++;
            } // if
          } // for
          if (nonicons <= 1) {
            throw new PropertyVetoException("Invalid Iconification!", _ev);
          } // if
        } // if
    } // vetoableChange(PropertyChangeEvent)
} // class IconPolice
