//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui1;

import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;

/**
* This class is responsible for defining the colors
* of the active and non active windows.
* Unused.
*/
public final class MexicTheme extends DefaultMetalTheme {

  /* active window */
  private ColorUIResource primary1_ = new ColorUIResource(3, 156, 189);
  private ColorUIResource primary2_ = new ColorUIResource(2, 190, 202);
  private ColorUIResource primary3_ = new ColorUIResource(243, 243, 186);

  /* non active window */
  private ColorUIResource secondary1_ = new ColorUIResource(3, 156, 189);
  private ColorUIResource secondary2_ = new ColorUIResource(91, 220, 249);
  private ColorUIResource secondary3_ = new ColorUIResource(176, 240, 244);
  
  /**
     * @return the string
     */
    public String getName() {return "Mexican";}

  /**
     * @return the ColorUIResource
     */
    protected ColorUIResource getPrimary1() { return primary1_; }
    
  /**
     * @return the ColorUIResource
     */
    protected ColorUIResource getPrimary2() { return primary2_; }
    
  /** 
     * @return ColorUIResource
     */
    protected ColorUIResource getPrimary3() { return primary3_; }

  /** 
     * @return ColorUIResource
     */
    protected ColorUIResource getSecondary1() { return secondary1_; }
    
  /**
     * @return ColorUIResource 
     */
    protected ColorUIResource getSecondary2() { return secondary2_; }
    
  /**
     * @return ColorUIResource
     */
    protected ColorUIResource getSecondary3() { return secondary3_; }

} // class MexicTheme