//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui1;

import ARoad0.gBaseInterface.BaseObject;


/**
 * This interface is responsible for handling the new base object
 * produced through a BaseObjectHandler.
 * The BaseObjectHandler caller
 * has to implement this interface (for instance, SimplePropertyEditor).
 * @version 0.5.1
 */
public interface NewBaseObjectListener {
  
  /**
   * Gets the value of the source.
   * @return the source of the property.
   */
  public BaseObject getSource();

  /**
  * Called by BaseObjectCreator for actionPerformed(),
  * when the property is a BaseObject
  * which has to be created from scratch.
  * @param _obj is the BaseObjectCreator instance to create
  */
  public void handleNewBaseObject(BaseObject _obj);
}