//Title:        Access Road
//Version:      0.7.0
//Copyright:    2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui2;

import java.awt.Font;
import javax.swing.ImageIcon;
import javax.swing.Icon;
import javax.swing.tree.DefaultTreeCellRenderer;
import java.net.MalformedURLException;

import ARoad0.Gui1.BeamerManager;
import ARoad0.Gui1.Desktop;


/**
 * This class is responsible for the look-an-feel setup into the trees.
 * It loads the cell icons for its two subclasses.
 * @version 0.7.0
 */
public class CommonTreeCellRenderer extends DefaultTreeCellRenderer {
    // variables
    protected static Icon        structureIcon;
    protected static Icon        ACS_ICON;
    protected static Icon        viewIcon;
    protected static Icon        groupIcon;
    protected static Icon        userIcon;
    protected static Icon        aclIcon;
    protected static Icon        actorIcon;
    protected static Icon        acsNodeIcon;
    protected static Icon        sResIcon;
    protected static Icon        rightIcon;
    protected static Icon        subsystemIcon;
    protected static Icon        virtualFolderIcon;
    protected static Icon        typedPrivilegeIcon;
    protected static Icon        linkedPrivilegeIcon;

    protected static Icon        closed_ACS_ICON;
    protected static Icon        isIcon;
    protected static Icon        closed_isIcon;
    protected static Icon        logicalcomponentIcon;
    protected static Icon        closed_logicalcomponentIcon;
    protected static Icon        physicalcomponentIcon;
    protected static Icon        closed_physicalcomponentIcon;
    protected static Icon        subacsIcon;
    protected static Icon        closed_subacsIcon;
    protected static Icon        compositeIcon;
    protected static Icon        closed_compositeIcon;

    /**
     * For the ACS icon of an AcsAddon. The default value is closed_ACS_ICON.
     */
    protected Icon               acsIcon_ = null;

    // constructors

  /**
   * Public constructor which sets the icons and the font size.
  */
  static {
    try {
      structureIcon = new ImageIcon();
      ACS_ICON = new ImageIcon(
                        Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                            Desktop.URL_SEPAR+"acs.gif").toURL() );
      viewIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"view.gif").toURL() );
      groupIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"group.gif").toURL() );
      userIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"user.gif").toURL() );
      aclIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"acl.gif").toURL() );
      actorIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"actor.gif").toURL() );
      acsNodeIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"acs_node.gif").toURL() );
      rightIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"right.gif").toURL() );
      subsystemIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"subacs.gif").toURL() );
      virtualFolderIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"virtual_folder.png").toURL() );
      typedPrivilegeIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"typed_privilege.png").toURL() );
      linkedPrivilegeIcon = new ImageIcon(
              Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"linked_privilege.png").toURL() );

      closed_ACS_ICON = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_acs.gif").toURL() );
      isIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"is.gif").toURL() );
      closed_isIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_is.gif").toURL() );
      logicalcomponentIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"logical.gif").toURL() );
      closed_logicalcomponentIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_logical.gif").toURL() );
      physicalcomponentIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"physical.gif").toURL() );
      closed_physicalcomponentIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_physical.gif").toURL() );
      subacsIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"subacs.gif").toURL() );
      closed_subacsIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_subacs.gif").toURL() );
      compositeIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"composite.gif").toURL() );
      closed_compositeIcon = new ImageIcon(
                    Desktop.AR_URI.resolve("Gui1"+Desktop.URL_SEPAR+"images"+
                        Desktop.URL_SEPAR+"closed_composite.gif").toURL() );

    } catch (MalformedURLException m) {
      m.printStackTrace();
    }
  } // static

  /**
   * Public constructor which sets the 'Serif' font and its size.
  */
  public CommonTreeCellRenderer() {
        acsIcon_ = ACS_ICON;

        setFont(new Font(
          "Serif", Font.PLAIN, BeamerManager.BEAMER_FONT_SIZE + 1));
  } // CommonTreeCellRenderer()


} // CommonTreeCellRenderer
