//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Gui2;

import javax.swing.tree.*;

/**
 * This interface is responsible for listening the events
 * fired by one main BaseObject (the main source) as ACSRun
 * and ViewInBase - and also the events fired by the main source objects-
 * for updating the unique JTree which is associated
 * to this TreeBaseListener and which displays the main source objects.
 * Each event source is registered only one time.
 * The main source opening and closing operations are not implied,
 * since these operations are handled in Gui1/Gui2 in the gDMak classes
 * ActionClose and ActionOpen.
 * @version 0.5.1
 */
public interface TreeBaseListener extends BaseListener {

 /**
 * Get the DefaultTreeModel associated to the ACS tree instance
 * in its construction.
 * @return DefaultTreeModel associated to the instance and to a JTree
 */
  public DefaultTreeModel getEorTreeModel();

 /**
 * Get the TreeModel root associated to the instance
 * in its construction.
 * @return MutableTreeNode associated to the instance in the TreeModel
 */
  public MutableTreeNode getEorRoot();

} // TreeBaseListener