//Title:        Access Road
//Version:      0.6.0
//Copyright:    Copyright 2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.Pattern;

/**
* from Grand patterns, the singleton pattern ensures that only one instance
* of a class is created. All objects that use an instance of that class
* use the same private instance that is got by
* ImplementingSingletonClass.getInstance().
* It's not possible to put the getInstance() method in the interface,
* because the return type is the class implementing the interface.
* So, the fields and method of the instance are put in the source code
* of this interface as comments.
* @version 0.5.0
**/
public interface Singleton {

  }


//----------------------  Template --------------------------------

//import ARoad0.Pattern.Singleton;


//public class ActionOpenUserV extends AbstractAction implements Singleton {

    /* the only instance of the class, following singleton pattern */
//  protected static ActionOpenUserV instance__ = new ActionOpenUserV();

    /* IconPolice also implements Singleton, and its getInstance() method returns
     * the only instance */
//  protected IconPolice iconPolice_ = IconPolice.getInstance();

    /* Exemple of a protected variable */
//  protected String select_ = null;

    /* with this private constructor, the compiler won't generate
     * a default public constructor
     */
//  private ActionOpenUserV() {
//    super("Open User View", new ImageIcon("images/copy.gif"));
//  } // constructor()

//  public static synchronized ActionOpenUserV getInstance(){
//    return instance__;
//  }; // getInstance()
