//Title:        Access Road
//Version:      0.6.0
//Copyright:    2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseBeanInfo;

import ARoad0.gBase.*;
import java.beans.BeanDescriptor;
import java.beans.PropertyDescriptor;

import ARoad0.Pattern.*;

/**
 * This class is responsible for describing the EPRViewInBaseImpl class.
 * It is used for displaying and editing the properties of the class.
 */
public class EPRViewInBaseImplBeanInfo extends ViewInBaseImplBeanInfo
  implements BeanInfoPattern {

  public EPRViewInBaseImplBeanInfo() {}

  /**
   * Get the description of the bean.
   * Specific values are set in the descriptor. They are get
   * with BeanDescriptor.getValue().
   * @return the bean descriptor
   */
  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor result = new BeanDescriptor(EPRViewInBaseImpl.class );
    result.setDisplayName("Full View");

    // 'withTabbedPanes' is true since several tabbed panes are necessary
    // to display all the panels (property, value) of EPRViewInBaseImpl
    result.setValue("withTabbedPanes", Boolean.TRUE );

    // ----------------------- other parameters ---------------------------

    // 'hidden' is true if the bean is hidden to the users, without
    // graphical user interface
    result.setHidden(false);
    result.setExpert(false);

    return result;
  } // getBeanDescriptor()

  /**
   * Each property descriptor has specific values that are get
   * with PropertyDescriptor.getValue()
   * @return array of property descriptors from the super class
   */
  public PropertyDescriptor[] getPropertyDescriptors() {

    PropertyDescriptor[] l_pdFromParent;
    PropertyDescriptor[] l_result;

      // start from the parent class bean info
      l_pdFromParent = super.getPropertyDescriptors();
      l_result = new PropertyDescriptor[l_pdFromParent.length];
      System.arraycopy(l_pdFromParent, 0, l_result, 0, l_pdFromParent.length);

      return l_result;
  } // getPropertyDescriptors()


} // EPRViewInBaseImplBeanInfo