//Title:        Access Road
//Version:      0.6.0
//Copyright:    2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard ( )
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/


package ARoad0.gBaseInterface;

import ARoad0.gBase.*;
import java.util.List;


/**
* This interface is responsible for modeling the access to a resource from an actor.
* Not implemented.
*/
public interface Access {

  /**
	 * @param _name
	 */
	public  void setName(Name _name);

  /**
	 * @return the name
	 */
	public  Name getName();

  /**
	 * @param _a : if it is true, the access to the resource is allowed ;
	 * if it is false, the access is forbidden.
	 */
	public  void setAllowForbid(boolean _a);

   /**
	 * @return true if forbid is allowed
	 */
	public  boolean getAllowForbid();

   /**
	 * @param _a : if it is true, the access is mandatory for the applications and
	 * users.
	 */
	public  void setNecessary(boolean _a);

   /**
	 * @return true if necessary
	 */
	public  boolean getNecessary();

   /**
	 * @param _a : if it is true, the access to the resource is associated to
	 * some registred risks.
	 */
	public  void setRisky(boolean _a);

   /**
	 * @return true if risky
	 */
	public  boolean getRisky();

   /**
	 * @param _l list of the actors which are implied in the accesses to this resource.
	 */
	public  void setL_Actors(List _l);

   /**
	 * @return list of actors
	 */
	public  List getL_Actors();

   /**
	 * @param _l : ordered list of the Grants and Locks associated with each actor in
	 * L_Actors of the resource.
	 */
	public void setL_GrantsLocks(List _l);

   /**
	 * @return list of grant locks
	 */
	public List getL_GrantsLocks();

}