//Title:        Access Road
//Version:      0.6.0
//Copyright:    2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

import java.beans.PropertyChangeListener;

/**
* This is the interface of a manager that fires PropertyChangeEvents
* when a BaseObject is deleted or closed.
* The action is associated to a property name.
* The methods are identical in BoundBean.
* It is implemented by BaseManager, ViewManager and others BaseObjects
* to inform Gui1.BeamerManager and the Gui1.XXXPropertyEditor.
* @version 0.5.1
*/
public interface BaseBeanManager {

  /**
  * Add a listener to the BaseBeanManager.
  */
  public void addPropertyChangeListener(PropertyChangeListener l);

  /**
  * Add a listener to the BaseBeanManager.
  */
  public void addPropertyChangeListener(String _propertyName,
    PropertyChangeListener _l);

  /**
  * remove a listener to the BaseBeanManager.
  */
  public void removePropertyChangeListener(PropertyChangeListener l);

  /**
  * remove a listener to the BaseBeanManager.
  */
  public void removePropertyChangeListener(String _propertyName,
    PropertyChangeListener _l);

} // BaseBeanManager