//Title:        Access Road
//Version:      0.6.0
//Copyright:    2002, 2004, 2007, 2008, 2009 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

import java.beans.PropertyChangeListener;

/**
* This is the interface of a bean that fires PropertyChangeEvents
* when a bound property is changed.
* It is implemented by most of the gBase classes.
* @version 0.6.0
* @since 0.5.1
*/
public interface BoundBean {

  /**
  * Add a listener to the bean.
  * @param _l the listener
  */
  public void addPropertyChangeListener(PropertyChangeListener _l);

  /**
  * Add a listener to the bean.
  * @param _propertyName the property to listen
  * @param _l the listener
  */
  public void addPropertyChangeListener(String _propertyName,
    PropertyChangeListener _l);

  /**
  * Remove a listener to the bean.
  * @param _l the listener
  */
  public void removePropertyChangeListener(PropertyChangeListener _l);

  /**
  * Remove a listener to the bean.
  * @param _propertyName the property to listen
  * @param _l the listener
  */
  public void removePropertyChangeListener(String _propertyName,
    PropertyChangeListener _l);
} // BoundBean