//Title:        Access Road
//Version:      0.7.0
//Copyright:    2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

import ARoad0.ErrB.UpDateError;

/**
* This is an interface to inform that there is a deleting method
* to be called by the beamer. Allows the user to delete this object, on the contrary of
* the super interface which is not declared in the BeanInfo of the gBase classes.
* @see FinalizedObject
*/
public interface FinalizedObjectForUser extends FinalizedObject {
  /**
   * This method is used by the user to finalize an ACS object.
   * May call super.finalizeForBase() if it is an ACSObject.
   * @exception UpDateError for instance if the object is immutable
   */
  public void finalizeForUser() throws UpDateError;
}