//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007-2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;


/**
* This interface is responsible for modeling any EligibleParty which is a group member.
*/
public interface GroupIDMember extends EligibleParty, ImmutableGroupIDMember {
   /**
   * Adds a group for which this GroupIDMember is a member.
   * Fires changes on 'AssociatedGroups'.
   * Called only by GroupID implementations..
   * @param _grp is the groupID to add. No action if it is null, or with null name.
   */
  public void addGroupToGM(GroupID _grp);

   /**
   * Removes a group for which this GroupIDMember is a member.
   * Fires changes on 'AssociatedGroups'.
   * No exception if _grp is not registered.
   * Called only by GroupID implementations.
   * @param _grp group to remove
   * @exception InternalError if _grp is not found
   */
  public void removeGroupToGM(ImmutableGroupID _grp);
}