//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;


/**
* This immutable interface is responsible for modeling
* a directory which contains children (resources and others directories).
* As a Linux/Unix directory, it may change its group
* and it has a sticky bit.
* On equals(), test of equals only on names
* and ACS names of children.
*/
public interface ImmutableDirectory extends ImmutableResource, ImmutableNode
{
    /**
    * @return boolean true if the groupID is changed for the newly-created files
    * to this directory groupID, and the newly-created sub-directories have
    * this property set to true.
    */
    public boolean getEnforceChildGID();

    /**
    * An array of external object references on the children
    *  of this node, which are resources.
    * @return ImmutableResource[]. May be empty or null.
    */
    public ImmutableResource[] getEorL_Children();

}

