//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

/**
* This interface is responsible for modeling any entity which is a group member.
* A GroupIdMember is a target for the CNot.AccessControlLink.RUN_UNDER relation.
*/
public interface ImmutableGroupIDMember extends ImmutableEligibleParty, ImmutableTarget {

  /**
   * Gets the groups for which this GroupIDMember is a member.
   * @return a copy of the groups belonging to this eligible party ACS.
   *    Never null. It may be an empty GroupIDImpl array.
   */
  public ImmutableGroupID[] getEorL_GroupID();
  
  /**
   * True only if the group member has an administrative role in the ACS, for
   * the technical administration or the users administration.
   */
  public boolean isAdmin();

}