//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007-2011 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

/**
* This interface is the immutable version of Node.
* It models a node having children, in a tree, where the deleting of the node
* produces the deleting of all its children.
* This is not the behavior of ImmutableFolder, which is also a container but
* without any constraint on the children deleting.
* @see ImmutableFolder
*/
public interface ImmutableNode extends ImmutableLeaf {

  /**
   * Deprecated to let Directory and VirtualFolder having their own methods.
  * An array of external object references on the children
  *  of this node, which may be leaves or nodes.
  * @return ImmutableLeaf[]. May be empty or null.
  * @deprecated
  */
  //public ImmutableLeaf[] getEorL_Children();

}

