//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

/**
 * Leaf is the usual interface for resources and virtual folders which are objects in a tree.
 * There is an ImmutableLeaf interface.
 * @version 0.7.0
 */
public interface Leaf extends ImmutableLeaf {
    
    /**
     * Defines the parent node and updates it, if necessary.
     * @deprecated Leaf.finalizeForBase() uses the protected method
     *  parent_.removeEorChild()
     * @param _nd the parent of this leaf, as an external
     *  object reference. The new parent may be updated.
     *  The previous parent is updated, except if it is the caller
     *  of this method or if this instance is a new clone.
     * @param _caller of this method; if it is the parent or this instance, the
     *   parent is not updated
     * @exception BaseError if the parent is not own by the resource acs.
     */
    //public void setEorParent(Node _nd, Object _caller) throws BaseError;


}

