//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation, with purely the version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details (gpl.html at the root of Access Road directory).
This license is applicable for 20 years since the publication of the program.
The applicable laws are the french ones, and the relevant court is at Nanterre (92).
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation, Inc.,
675 Mass Ave, Cambridge, MA 02139, USA.
*/

package ARoad0.gBaseInterface;

//import ARoad0.ErrB.BaseError;

/**
 * A node is a container of leaves or others nodes in a tree of ACSObjects.
 * Directory and VirtualFolder are nodes.
 * There is an ImmutableNode interface which contains all the get methods
 * of this Node interface.
 */
public interface Node extends ImmutableNode, Leaf {
  /**
   * Set parent_ to null in the deprecated children, except the caller.
   * The new children array is sorted  with ImmutableLeaf.compareTo(),
   * since the argument ImmutableResource[] can be replaced with ImmutableLeaf[],
   * and null are removed.
   * 'Children' is a bound property.
   * <P>
   * @param _l_Child array of leaves which are in this directory. May be
   *  equal to ResourceImpl.EMPTY_INSTANCE, or null.
   * @param _caller of the method, to avoid to update its parent variable
   *  if it is a just-updated child, already registred or not as a child of this node.
   *  May be this instance to have no action
   * @exception BaseError if a leaf is not owned by the main ACS of
   *  this directory (or InternalError for several rare conditions)
   */
  //public void setEorL_Children(ImmutableLeaf[] _L, Object _caller) throws BaseError ;

  /**
   * Call the other setEorL_Children() with the _caller argument equal to
   * this instance to have no action.
   * This method is created for the BeanInfo; it is used from Gui1 package.
   * Caution: never call this method from a new or a deprecated child
   * of this node; use then the other method.
   * <P>
   * @param _l_Child array of leaves which are in this node. May be
   *  equal to ResourceImpl.EMPTY_INSTANCE, or null.
   * @exception BaseError if a leaf is not owned by the main ACS of
   *  this directory (or InternalError for several rare conditions)
   */
  //public void setEorL_Children(ImmutableLeaf[] _l_Child)
    //throws BaseError;

  
} // Node

