//Title:        Access Road
//Version:      0.7.1
//Copyright:    2012 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

/**
* This is an interface to inform that it is an object with a previous detailled name
* which gives the key components of the object. Allows a clearer presentation
* of an object in the explorer and into the beamer. <P>
* An external object has a detailled name starting with 'ACS: acs_name | '.
* When the state of external changes, this method allows to get the previous detailled name,
* with or without the ACS name. Otherwise, the previous detailled name is the detailled name.
*/
public interface PreviousDetailledName extends DetailledName {


  /**
  * This method returns the previous detailled name for the explorer,
  * which gives the key components of the object.
  * An external object has a detailled name starting with 'ACS: acs_name | '.
  * When the state of external changes, this method allows to get the previous detailled name,
  * with or without the ACS name. Otherwise, the previous detailled name is the detailled name.
  * @return the detailled name if it has not changed, or the other version of the detailled name
  */
  public String getPreviousDetailledName();

}
