//Title:        Access Road
//Version:      0.7.0
//Copyright:    2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls


/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation, purely version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details (gpl.html at the root of Access Road directory).
This license is applicable for 20 years since the publication of the program.
The applicable laws are the French ones. The relevant court is at Nanterre (92).
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation, Inc.,
675 Mass Ave, Cambridge, MA 02139, USA.
*/

package ARoad0.gBaseInterface;


 /**
 * This interface is responsible for modeling the superclass of both
 * the privilege source and the privilege target interfaces, for
 * BasicImpl.
 * A privilege instance is controlled by its ACS, and it is a static set of rights
 * which are applicable to any couple (source, target) which is compliant to
 * some precise criteria.
 * There are different types of privilege, defined in PrivilegeAbst
 * class, implying different access control criteria.
 * The sources and the targets are defined through
 * dynamic or static links to the privilege, following the type.
 * The rights are always statically defined at the creation of the privilege.
 * See the <a href="{@docRoot}/copyright.html">Copyright</a>.
 * @see ARoad0.gBase.PrivilegeAbst
 * @see ARoad0.gBaseInterface.PrivilegeSource
 * @version 0.5.3
 */
public interface PrivilegeUser extends ACSObject { 

} // PrivilegeUser