//Title:        Access Road
//Version:      0.7.0
//Copyright:    2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gBaseInterface;

import java.util.List;

import ARoad0.ErrB.BaseError;

/**
 * This interface is responsible for modeling in the base, a sketch view
 * about access control issues between access sources and an ACSObject (called the center),
 * and between this center and access targets (Resources or VirtualFolders).
 * It is used by the sketch views in the GUI, so there is only one running instance,
 * and it is never saved on the base.
 * @see ARoad0.Gui2.GraphicSketchView
 */
public interface SketchViewInBase extends EPRViewInBase {

  /**
   * Sets the BaseObjects displayed in the sketch view, including the center.
   * The view is not registered to not listen the changes in the view objects,
   * on the contrary of the add/remove methods.
   * Called by gDMak.ActionOpenSketcher.openSelection().
   * @param _list of BaseObjects to display in the view. Not null.
   * @exception BaseError if _list is empty.
   */
  public void setEorL_BaseObjectsForSketcher(List<BaseObject> _list) throws BaseError;

} // SketchViewInBase
