//Title:        Access Road
//Version:      0.7.0
//Copyright:    2002, 2004, 2007, 2008, 2009, 2010 EURL ACCBEE
//Author:       Patrick Thazard
//Description:  a simulator, designer and controller for IT system access controls

/* This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 3 of the License,
or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

package ARoad0.gDMak;

import javax.swing.*;
import java.awt.event.*;
import ARoad0.Pattern.*;
import ARoad0.Gui1.*;

/**
 * An action that displays information about the software license.
 * @version 0.7.0
 */
public class ActionAboutARoad extends AbstractAction implements Singleton {

  /* the only instance of the class, following singleton pattern */
  private static ActionAboutARoad   instance__ = new ActionAboutARoad();

  // environment
  private static String             lineSepar__ = System.getProperty("line.separator");


  /**
   * with this private constructor, the compiler won't generate
   * a default public constructor
   */
  private ActionAboutARoad() {
    super("About Access Road");
  }
  /**
   * constructor()
   * @return ActionAboutARoad
   */
  public static synchronized ActionAboutARoad getInstance(){
    return instance__;
  } // getInstance()

  /**
   * @param ev
   */
  public void actionPerformed(ActionEvent ev) {
    DialogBox.showOkMessage(
          "Access Road version 0.7.1"+
          lineSepar__+
          lineSepar__+
          "Contact: patrick.thazard /AT/ accessroad /point/ info"+
          lineSepar__+
          lineSepar__+
          "This is a free software with a GNU Affero General Public License version 3. "+
          "You can redistribute it and/or modify it under the terms of "+
          "the license."+
          " See the agpl.html file for more details on the software license."+
          " This file is under 'your_AccessRoad_directory'/classes/ARoad0/Gui1/help."+
          " This program is distributed in the hope that it will be useful,"+
          " but WITHOUT ANY WARRANTY; without even the implied warranty"+
          " of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."+
          " The documentation licence is the GNU Free Documentation License."+
          " See the file gfdl.html under the same directory."+
          lineSepar__+
          lineSepar__+
          "Copyright 1999-2012 ACCBEE for all the code"+
          " and all the documentation.");
  } // actionPerformed(ActionEvent)

} // class ActionAboutARoad